#!/usr/bin/perl
use CGI::Carp qw(fatalsToBrowser);

#########
# Affiliate Coder - a script to output affiliate HTML code. 
# by T. O' Donnell.  
# Copyright T. O' Donnell, 2001.
#########

# File Locking.
# Does your system have file locking ('flock')?  This stops your data 
# files getting corrupted when to different users try to save to the 
# same file simultaneously.  If it does, change the following value to
# 1, e.g. $lockit = 1;. If you're on a Windows server, set it to 0.

$lockit = 1;

# Absolute path to your HTML template:
$path_to_template = "/user/yourserver/absolute/path_to/cgi-bin/affil_coder/affil_template.txt";

# Absolute path to your output file (so this script can access it):
$path_to_output_file = "/user/yourserver/absolute/path_to/affil_coder/affil_coder.html";

# URL pf your output file (which the surfer will be redirected to):
$url_of_output_file = "http://www.tigertom.com/affil_coder/affil_coder.html";

# Valid partial referring URLs, 
# i.e. what will the referring URL *start* with:
@main_urls = ('http://www.tigertom.com/affil_coder/', 'http://tigertom.com/affil_coder/', 'http://66.33.65.177/affil_coder/',);

###################### End of user-defined variables ##################################

## Activate sub-routines

&referer_check;
&get_form_data;
&required_check;
&save_id;
&redirect_user;
exit;

######### The sub routines ###################

# valid referrer check

sub referer_check {

foreach $referer(@main_urls) {
	if($ENV{'HTTP_REFERER'} =~ /^$referer/i){
	$okay = 1;	
	      }
         }
 if (!$okay) {
print "Content-type: text/html\n\n";
print "INVALID REFERER.\n\n";
 exit(0);
     }

 } # End sub


sub get_form_data {
	$buffer = "";
	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	@pairs=split(/&/,$buffer);
	$buffer =~ s/([;\*\|\`'\$#\[\]\{\}])/\\$1/g; # extra security
	foreach $pair (@pairs) {
		@a = split(/=/,$pair);
		$name=$a[0];
		$value=$a[1];
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$value =~ s/~!/ ~!/g;
		$value =~ s/\+/ /g;
		$value =~ s/\</\&lt\;/g;  # html tag removal (optional)
		$value =~ s/\>/\&gt\;/g;  # html tag removal (optional)
		$FORM{$name} = $value;
          
             } # End foreach

 if (length($value) > 64)  {
print "Content-type: text/html\n\n";
print "FORM INPUT VALUE TOO LONG.\n\n";
 exit(0);
           }

# Assign the ID to a scalar, and get rid of spaces.
$id = $FORM{'id'};
$id =~ s/ //g;         

   } # End sub

# Check required field is filled in:
sub required_check {

        if (!$FORM{'id'}) {

print "Content-type: text/html\n\n";
print "<center><h3><FONT COLOR=\"\#FF0000\">Error - Missing Form Information!</FONT></h3><br></center>\n";
print "It seems that you've forgotten to fill out the ";
print "<b><FONT COLOR=\"#FF0000\">$field</FONT></b> "; 
print "field in the form.\n";
print "Please use your browser's back button and correct this.\n";
print "Thank You.</P>\n";
exit;
      } # End if
   } # End sub


sub save_id {

 open (RECORD, "<$path_to_template") || die "Error - cannot open $path_to_template: $!";
         if($lockit){flock(RECORD,2);}
         @htmlcode = <RECORD>;
         if($lockit){flock(RECORD,8);}
         close (RECORD);


 open (RECORD, ">$path_to_output_file") || die "Error - cannot open $path_to_output_file: $!";
         if($lockit){flock(RECORD,2);}
         foreach $line(@htmlcode) {
         chomp($line);
         $line =~ s/THEIR_AFFILIATE_ID/$id/g;
            print RECORD "$line\n";
                             
              } # End foreach
                             
         if($lockit){flock(RECORD,8);}
         close (RECORD);

   } # End save id  

# Redirect them 
sub redirect_user {   
    print "Location: $url_of_output_file\n\n";
     exit;  
      }
   # End sub   

